<?php

// McData, (c) 2002 mackstann
// contact:  mackstann at myrealbox.com
// website:  http://mackstann.cjb.net/
// license:  Public Domain

/* README
 *
 * -------QUICK STARTUP
 * change $mysql_user and $mysql_pass, do the same in the
 * included setup.php file, visit the setup.php with your browser,
 * confirm it worked without error, then you're free to use mcdata
 * in any page by just putting <?php include("/path/to/mcdata.php"); ?>
 * mcdata will appear at whatever point in the page you put that.
 *
 * if you want multiple instances of mcdata, just copy edit setup.php
 * to have a different dbname, make a new copy of mcdata.php, edit it's
 * dbname to match the new dbname, and then include it as usual.
 * good luck!
 * -------
 *
 * README TOO
 *
 * the admin key is "?fart=1".  for example if your page with McData
 * is at 
 *
 * http://something.com/index.php
 *
 * you would change it to
 *
 * http://something.com/index.php?fart=1
 *
 * or if there are already other variables there, use a & like this:
 *
 * http://something.com/index.php?s=yes&fart=1
 *
 * using the admin key turns off html stripping, so you can use normal
 * html and even php in your post, and it also converts mctags.  the
 * other thing it does is allow you to submit posts on the main listing
 * whereas users can only submit replies.
 * 
 * the key is fart by default but you can change that right here:
 */
 
 	$key = "fart";

/* yes this is a strange way to control access but frankly i'm
 * too lazy to do it a better way right now.  
 */
function McData()
{
	/*---------------------------------------------------\
	| these should be pretty self explanatory, edit them |
	| to fit your situation                              |
	\---------------------------------------------------*/

		
		$mysql_host   = "localhost";
		$mysql_user   = "user";
		$mysql_pass   = "password";
		$mysql_dbname = "McData";

 /*---------------------------------------------------------------------------\
 |                  you're done, dont edit past this point!                   |
 \---------------------------------------------------------------------------*/

	//set up the mysql connection
	$db = mysql_connect($mysql_host,$mysql_user,$mysql_pass);
	
	//select the database
	mysql_select_db($mysql_dbname,$db);
	
	//should we put a form on the page or not?
	formdecision();

	//if this page is the result of a person posting a message,
	//and they filled in both name and message fields, then
	//submit the post.
	if($_POST['name'] && $_POST['message'])
		submitpost($_POST['name'],$_POST['message']);

	//load the posts from the database
	$result = loadposts($db,$_GET['mid']);

	//and print them out
	printposts($result);
}

/* formdecision() - figure out whether we are inside of a post
 * or out on the main listing, and decide to make the form or not
 * based on that
 */
function formdecision()
{
	//if there's a mid, that means we're inside of a post,
	//so we make the form
	if($_GET['mid'])
		makeform($_GET['mid']);
	
	//otherwise, we dont make the form
	else
	{
		//unless we put the secret key in!
		if($_GET[$key] == 1)
			makeform(0);
	}
}				

/* replies() - count how many replies there are to a post by counting
 * the number of other posts whos parentid corresponds to the given
 * message id.  replies() is called by printrow()
 */
function replies($mid)
{
	//count how many posts' parentid equals the current message id.
	$countreplies = mysql_db_query(McData,"SELECT count(*) FROM posts WHERE parentid = '$mid'");

	//and return it
	$replies = mysql_result($countreplies,0,0);
	return $replies;
}

/* mctags() - replace special mctags ([b], [i], [l]) with the
 * corresponding html
 */
function mctags($string)
{
	//do the [l] tags
	$string = eregi_replace("\[L=(.*)]","<a href=\"\\1\">",$string);
	$string = eregi_replace("\[/L]","</a>",$string);
	
	//[b] tags
	$string = eregi_replace("\[B]","<strong>",$string);
	$string = eregi_replace("\[/B]","</strong>",$string);

	//[i] tags
	$string = eregi_replace("\[I]","<em>",$string);
	$string = eregi_replace("\[/I]","</em>",$string);
	
	//now return the mctagified message
	return $string;
}			

/* makeform() - print out the form for submitting posts
 */
function makeform($mid)
{
	//if there's a message id with a real value, then make the form
	//bring you back to that page after you submit
	if($mid != 0)
		$returnurl = "/?mid=" . $mid;
	
	//otherwise, return you to the main page (only used by admin-person)
	else
		$returnurl = "/";
	
	//html time! basically, just make the form.  self explanatory.
	?>
	
	<div class="sub">
	<form method="post" action="<?=$returnurl?>">
		<strong>McTags</strong>:  
		<strong>[L=http://url]</strong>hypertext link
		<strong>[/L]</strong>, 
		<strong>[b]</strong>bold<strong>[/b]</strong>, and 
		<strong>[i]</strong>italic<strong>[/i]</strong>
		
		<br /><br />
		
		Hello <strong> <?=$_SERVER['REMOTE_ADDR']?></strong>
		
		<br /><br />
		
		name:<br />
		<input type="text" name="name" size="30" maxlength="16" class="textbox">
		</input>
		
		<br /><br />
		
		message:
		<br />
		<textarea name="message" rows="4" cols="30" class="textbox">
		</textarea>
		
		<br />
		<input type="submit" name="submithit" value="Submit" class="button"></input>
	</form>
	</div>
	
	<?php
	//and our form is done
}

/* submitpost() - submit a post into the database
 */
function submitpost($name,$message)
{
	//if there is a mid, then assign this post's parentid to that mid
	//so it shows up as a child of that post
	if($_GET['mid'])
		$pid = $_GET['mid'];

	//otherwise the parentid is zero, and it will show up on the main
	//listing
	else
		$pid = 0;
	
	//now insert the post into the db
	$sql = "INSERT INTO posts (name,date,message,parentid) VALUES ('$name',NOW(),'$message','$pid')";
	$result = mysql_query($sql);
}

/* loadposts() - load up the posts from the db to show on the page
 */
function loadposts($db,$mid)
{
	//if we're inside a message, load its children
	if($mid)
	{
		$result = mysql_query("SELECT * FROM posts WHERE mid=\"$mid\" OR parentid=\"$mid\" ORDER BY mid DESC",$db);
	}
	
	//otherwise just display all messages
	else
	{
		$result = mysql_query("SELECT * FROM posts WHERE parentid=\"0\" ORDER BY mid DESC",$db);
	}
	return $result;
}		

/* printposts() - print out the posts!
 */
function printposts($result)
{
	echo "\n<!-- McData Begins! -->\n";
	
	//for every post
	while($row = mysql_fetch_row($result))
	{
		//strip the tags and mctagify, UNLESS its the admin!
		//if its the admin, then html is accepted
		if($_GET[$key] != 1)
		{
			$row[0] = strip_tags($row[0]);
			$row[2] = strip_tags($row[2]);
			$row[2] = mctags($row[2]);
		}
		//print the row
		printrow($row[0],$row[1],$row[2],$row[4]);
	}

	//wrap it up
	echo "<br />";
	echo "\n<!-- End of McData stream -->\n";
}

/* printrow() - its called for each post by printposts(), it does the work
 * of laying out the html and stuff for each post
 */
function printrow($thename,$thedate,$themessage,$mid)
{
	//if we're inside a message, then print the 'simple' version
	if($_GET['mid'])
	{
		printf("\n<br /><div class=\"sub\">\n
	<span class=\"color\">Posted by </span><strong>%s</strong><span class=\"color\"> @ %s</span>\n
	<br /><br />%s\n
	<br /><br />\n
</div>\n\n",$thename,$thedate,$themessage);
	}

	//and if we're outside on the main listing, then show the number
	//of replies, and the view/reply button.
	else
	{	
		//call replies() to calculate the # of replies for this post
		$replies = replies($mid);
		
		//use correct english : )
		$word = "replies";
		if($replies == 1)
			$word = "reply";

		//print the html
		printf("\n<br /><div class=\"sub\">\n
	<span class=\"color\">Posted by </span><strong>%s</strong><span class=\"color\"> @ %s</span>\n
	<br /><br />%s\n
	<br /><br /><strong>%s %s</strong> - <a href=\"%s?mid=%s\">View/Reply</a>\n
	<br />\n
</div>\n\n",$thename,$thedate,$themessage,$replies,$word,$_SERVER['PHP_SELF'],$mid);
	}
}

//and now, put it to action!
McData();

//thats it!

?>
